import ij.*;
import ij.plugin.*;
import ij.plugin.frame.*;
import java.awt.*;
import java.util.*;
import javax.swing.*;
import java.awt.event.*;
import UroIrmPackage.*;

public class Open_Parametre_ extends PlugInFrame implements PlugIn,ItemListener,ActionListener,UroIrmMessage{
	private Frame instance;
	
	Dialog dg;
	private Hashtable table;
	private java.awt.List liste;
	private Checkbox check;
	
	boolean cancel = false;
	static String LABEL_OK = "  OK  " , LABEL_CANCEL ="CANCEL";
	Panel panelList = new Panel();
	DicomPref dico; 
	Dimension dimScreen ;
	int listCount =0;
	static Color couleur = Color.lightGray;
	static Font fontLabel = new Font("SansSerif",Font.PLAIN,12);
	static int minumsize = 2;
	static Label labelSelectedNumber;
	static int nbSelectedElement = 0; 
	static boolean confidentiel =true;

	public Open_Parametre_() {
		super("Open_Parametre...");
		instance = this;
		dimScreen = (Toolkit.getDefaultToolkit()).getScreenSize();
		PrefSaveResult.load();
		confidentiel = (PrefSaveResult.getInt("confidentiel",0)!=0);
		dico = new DicomPref();	
		table = new Hashtable();
		load(table);
	}
	
	public void run(String arg){
		showDialog();
	}

/** display the windows */
	void showDialog() {
		instance.setSize(dimScreen.width*3/7,dimScreen.height*4/6);
		instance.setBackground(couleur);
		String[] group = {"red","green"};
		String[] buttons = { LABEL_OK,LABEL_CANCEL};
		liste = new java.awt.List(4);
		check = new Checkbox(msg_comm_confidentiel,confidentiel);
		String txt = THERE_ARE + String.valueOf(nbSelectedElement);
		txt += msg_comm_selected_element;
		labelSelectedNumber = new Label(txt,Label.LEFT);
		Box gestion = Box.createVerticalBox();
		add(gestion);
		addMessage(gestion,msg_comm_explicatif,Label.LEFT);
		addLabel(gestion,labelSelectedNumber);
		addChoice(gestion,msg_comm_type,DicomPref.DIVERS);
		addList(gestion,liste);
		addCheckBox(gestion,check);
		addButtons(gestion,buttons);

		instance.add(gestion);
		if (IJ.isMacintosh())
       			instance.setResizable(false);
		instance.setVisible(true);
	}

/** initializes the "table" */
	void load(Hashtable table){
		int[] dataDefault = dico.getPref(DicomPref.keyDicom,DicomPref.defaultValue);
		int i=0,count=0;
		for (Enumeration e = dico.getDicoNames();e.hasMoreElements();){
			String res = (String)e.nextElement();
			String value = (dico.getArgument(res,1));
			String donnee ="";
			int current = i%32;
			if (  (( 1<<current ) & dataDefault[count])!=0  ){
				donnee += YES+res ; nbSelectedElement ++;
			} else 
				donnee += NO + res;
			donnee += "|=|" + String.valueOf(i); 
			if ( !table.containsKey(value) ) 
				table.put(value,new LinkedList());
			((LinkedList)(table.get(value))).add(donnee);

			if ( current == 31 ) 	
				count ++;
			i++;
		}
	}

/** initializes the Linkedlist "liste" */
	void setLinkedList(){
		LinkedList current = (LinkedList)table.get(String.valueOf(listCount));
		ListIterator iter = current.listIterator(0);
		while( iter.hasNext()){
			String text = (String)iter.next();
			int index = text.indexOf("|=|");
			liste.add(text.substring(0,index));
		}
	}

/** add the "liste" to the window */
	public void addList(Box contenu,java.awt.List liste){
		setLinkedList();
		liste.addItemListener(this);
		contenu.add(liste);
	}

/** add a choice to the window*/
	public void addChoice (Box contenu,String label,int start){
		Choice choix = new Choice();
		JPanel pane = new JPanel();
		pane.setBackground(couleur);
		pane.setMaximumSize(new Dimension(dimScreen.width,minumsize));
		for (int i =0 ; i< DicomPref.label.length ;i++){
			choix.add(DicomPref.label[i]);
		}
		choix.addItemListener(this);
		choix.select(start);
		listCount = start;
		Label labCurrent = new Label(label,Label.LEFT) ;
		labCurrent.setFont(fontLabel);
		pane.add(labCurrent);
		pane.add(choix);
		contenu.add(pane);
	}

/** add a CheckBox to the window */
	public void addCheckBox(Box contenu,Checkbox check){
		JPanel pane = new JPanel();
		pane.setBackground(couleur);
		pane.setMaximumSize(new Dimension(dimScreen.width,minumsize));
		pane.add(check);
		contenu.add(pane);
	}
	
/** add a Message to the window */
	public void addMessage(Box contenu, String text, int position){
		JPanel pane = new JPanel();
		pane.setBackground(couleur);
		pane.setMaximumSize(new Dimension(dimScreen.width,minumsize));
		for (StringTokenizer chaine = new StringTokenizer(text,"\n");chaine.hasMoreElements();){
			Label labCurrent = new Label((String)chaine.nextElement(),position);
			labCurrent.setFont(fontLabel);
			pane.add(labCurrent);
		}
		contenu.add(pane);
	} 

/** add a label to the window */
	public void addLabel(Box contenu,Label label){
		JPanel pane = new JPanel();
		pane.setBackground(couleur);
		pane.setMaximumSize(new Dimension(dimScreen.width,minumsize));
		label.setFont(fontLabel);
		pane.add(label);
		contenu.add(pane);
	} 
	
/** add a group of buttons given by "label" to the window*/
	public void addButtons(Box contenu,String[] label) {
		JPanel pane = new JPanel();
		pane.setBackground(couleur);
		pane.setMaximumSize(new Dimension(dimScreen.width,minumsize));
		Box gestion = Box.createHorizontalBox();
		pane.add(gestion);
		int i ;
		for (i=0;i<label.length-1;i++){
			Button b = new Button(label[i]);
			b.addActionListener(this);
			gestion.add(b); gestion.add(Box.createHorizontalStrut(10));
		}
		Button b = new Button(label[i]); b.addActionListener(this);
		gestion.add(b);
		
		contenu.add(pane);
	}

// for the interaction of the window 
	public  void itemStateChanged(java.awt.event.ItemEvent e ) {
		int index = 0;
		boolean choix = false;
		
		try {index = Integer.parseInt(e.getItem().toString());}
 		catch (NumberFormatException ex) {
			choix = true;
		}
		if ( choix)
			changeChoice(e.getItem().toString());
		else
			changeValue(index);
	}

	public void actionPerformed(ActionEvent e) {
		String command = e.getActionCommand();
		if ( command == null)
			return ;
		if ( command.equals(LABEL_OK))
			cancel=false;
		else 
			cancel = true;		
		instance.setVisible(false);
		instance.dispose();
		instance=null;
		saveResult();
	}

// Change the list according to "type" and display the new list.
	void changeChoice(String type){
		int counter = 0 ;
		for ( counter =0 ; counter< DicomPref.label.length;counter++){
			if ( type.equals(DicomPref.label[counter]))
				break;
		}
	// if ( counter == DicomPref.label.length) {IJ.error("Probleme of processing");}
		liste.removeAll();
		listCount = counter;
		setLinkedList();
		instance.repaint();

	}
	
// change the status of the selected line of the list and display it
	void changeValue(int index){
		String text =liste.getItem(index);
		String res = "";
		int start = NO.length();
		if ( (text.substring(0,start)).equals(NO) ) {
			res += YES;nbSelectedElement++;
		} else {
			res+=NO ;nbSelectedElement--;
		}
		remplaceItemTable(res,index);
		res += text.substring(start);	
		liste.replaceItem(res,index);
		liste.select(index);
	
		String txt = THERE_ARE + String.valueOf(nbSelectedElement);
		txt += msg_comm_selected_element;
		labelSelectedNumber.setText(txt);
		instance.repaint();
	}

// change the status "dest" of an item "index" of a LinkedList 
//	( element of the Hashtable "table" )
	void remplaceItemTable(String dest, int index ){
		LinkedList current = (LinkedList)table.get(String.valueOf(listCount));
		String text = (String)current.get(index);
		int start = NO.length();
		String res = dest + text.substring(start);
		current.set(index,res);
	}

// save the result in the window was not canceled
	void saveResult(){
		if (cancel) 
			return ;
		// save the checkBox value
		boolean isSave = true ;
		if(check.getState())
			isSave &= PrefSaveResult.save("confidentiel",1);
		else 
			isSave &= PrefSaveResult.save("confidentiel",0);
		// save the list value
		int start = NO.length();
		String text;
		int[] res  = new int[(dico.getDictionary()).size()/32+1];
		int counter = 0, index = 0,v=0 ;
		for ( Enumeration e = table.keys() ; e.hasMoreElements();){
			LinkedList listCurrent = (LinkedList)(table.get((String)e.nextElement()));
			ListIterator iter = listCurrent.listIterator();
			while ( iter.hasNext()){
				text =  (String)iter.next();
				index = text.indexOf("|=|") + 3;
				v = s2i(text.substring(index));
				if ( (text.substring(0,start)).equals(YES) ) 	{
					int current = v%32;
					int mod = v/32;
					res[mod] |= (1<<current);
					counter++;
				}
			}
		}
		String value="";
		for ( int i =0;i<res.length;i++){
			value += String.valueOf(res[i]) + ":";
		}
	  	isSave &= dico.save(DicomPref.keyDicom,value);
		if ( !isSave ) 
			IJ.error(msg_err_pb_write+"\n"+msg_err_no_data_save);
	}


	public void windowClosed(WindowEvent e) {
		setVisible(false);
		instance = null;
	}
	
	private static int s2i(String s){
		try{ return( (new Integer(s)).intValue());}
		 catch( NumberFormatException e ){	return -1;}
	}

}

