package UroIrmPackage;

/** this interface is destinated for the class HeaderDicom .
	it contains all the information to create the title of the Dicom stack
	and the label of each image 
	This information is classified in 3 groups : 
		the DATE_TAG contains all informations that deal with date
		the TIME_TAG contains all informations that deal with time
		the GENERAL_TAG for the rest.
*/
	
public interface Header{
// The mark for the header	
	public static final String SLICE_SEPARATOR = " ;" ;
	public static final String STACK_SEPARATOR = " : " ;
	public static final String TOKEN_SEPARATOR = ":";
	public static final String STACK_KEY = "InfoDicomStack";
	
// general information
	public static final String STACK = " stack ";
	public static final String UNKNOWN = " unknown ";
	public static final String UNKNOWN_PERSON = " (unknown person) " ;
	public static final String ENABLE = " enable ";
	public static final String DISABLE = " disable " ;

	public static final String TYPE_GENERAL_TAG = " general_tag";
	public static final String TYPE_DATE_TAG = " date_tag";
	public static final String TYPE_TIME_TAG = " time_tag";

	public static final String PERSONN = " name ";
	public static final String PATIENTID = " patient ID ";
	public static final String ETAT = " Etat = " ;
	public static final String TITLE = "title = ";
	public static final String STUDYDESCRIP = " Study Description ";
	public static final String[][] GENERAL_TAG = {{PERSONN, "0010,0010" },
				{PATIENTID,"0010,0020"},
				{ETAT,ETAT},
				{TITLE,TITLE},
				{STUDYDESCRIP,"0008,1030"}
				};

	public static final String ACQDATE = " date ";
	public static final String[][] DATE_TAG = {{ACQDATE,"0008,0022"}};

	public static final String ACQTIME = " time acq :  " ;
	public static final String ACQHOUR = " hour ";
	public static final String[][] TIME_TAG = {{ACQTIME,"diff"},{ACQHOUR,"0008,0032"}};

/** all the informations destinated for each image */
	public static final String[] SLICE_TAG ={ACQTIME,ETAT,TITLE};
/** all the informations destinated for the title of the dicom stack*/
	public static final String[] STACK_TAG={PERSONN,ACQDATE,ACQHOUR,PATIENTID,STUDYDESCRIP};
	
}
